// Copyright 2006 NFC Corporation.  All rights reserved.
// Redistribution is Prohibited.

#include <WINSOCK2.H>

typedef struct
{
	unsigned char Flag;
	unsigned char Major;
	unsigned char Minor;
	unsigned char Release;
}Version;

typedef struct
{
	unsigned int year;
	unsigned char month;
	unsigned char day;
	unsigned char hour;
	unsigned char minute;
	unsigned char second;
}DateTime;

typedef struct
{
	unsigned char TagType;
	unsigned char AntNum;
	unsigned char Length;
	unsigned char Ids[ID_Length];
}TagIds;

typedef struct
{
	unsigned char DataMask;
	unsigned char EpcLength;
	unsigned char TidLength;
	unsigned char UserLength;
	unsigned char Epc[30];
	unsigned char Tid[12];
	unsigned char User[64];	
}Gen2TagList;

typedef struct
{	DateTime DateTime;
	unsigned char TagType;
	unsigned char AntNum;
	unsigned char Ids[ID_Length];
}OLTagIds;

typedef struct 
{
	unsigned char Mask;
	unsigned char Action;
}Gen2LockFlag;

typedef struct
{
	Gen2LockFlag Kill;
	Gen2LockFlag Access;
	Gen2LockFlag EPC;
	Gen2LockFlag TID;
	Gen2LockFlag User;
}Gen2LockFlags;

//reader manage function
short __declspec(dllexport) __stdcall SelectStation (unsigned char StationNum);
short __declspec(dllexport) __stdcall OpenReader (HANDLE *hCom, unsigned char LinkType,char *com_port);
short __declspec(dllexport) __stdcall CloseReader (HANDLE hCom);
short __declspec(dllexport) __stdcall SetBaudRate(HANDLE hCom, unsigned short BaudRate);
short __declspec(dllexport) __stdcall SetParameter(HANDLE hCom, unsigned int Addr, unsigned char Count,unsigned char * value); 
short __declspec(dllexport) __stdcall GetiParameter(HANDLE hCom, unsigned int Addr, unsigned char Count,unsigned char *value);
short __declspec(dllexport) __stdcall ResetReader (HANDLE hCom);
short __declspec(dllexport) __stdcall Synchronize (HANDLE hCom);
short __declspec(dllexport) __stdcall GetFirmwareVersion (HANDLE hCom, Version * version);
short __declspec(dllexport) __stdcall GetSdkVersion (HANDLE hCom, Version * version);
short __declspec(dllexport) __stdcall Power(HANDLE hCom, unsigned short Mode, unsigned char PowerLevel);
short __declspec(dllexport) __stdcall SetWorkAntenna (HANDLE hCom, unsigned char Antenna);
short __declspec(dllexport) __stdcall SetAntennaCycle (HANDLE hCom, unsigned char Cycle) ;
short __declspec(dllexport) __stdcall AntennaQuery( HANDLE hCom, unsigned short* Receive,   unsigned short* Transmit);
short __declspec(dllexport) __stdcall StopRFwork(HANDLE hCom);
short __declspec(dllexport) __stdcall QueryTags(HANDLE hCom, unsigned int TagType, unsigned int * Count,TagIds *value) ;
short __declspec(dllexport) __stdcall SelectAntenna(HANDLE hCom, unsigned char AntennaNum) ;

//tag operation function
short __declspec(dllexport) __stdcall SingleTagIdentify(HANDLE hCom, unsigned int TagType, unsigned char *value) ;
short __declspec(dllexport) __stdcall SingleTagIdentifyVar(HANDLE hCom, unsigned int TagType, unsigned char *value) ;
short __declspec(dllexport) __stdcall IdentifyRailTag(HANDLE hCom, unsigned char  DataType, unsigned char *value) ;
short __declspec(dllexport) __stdcall IdentifyContainerTag(HANDLE hCom, unsigned char  DataType, unsigned char *value);
short __declspec(dllexport) __stdcall SingleTagIdentifyEx(HANDLE hCom, unsigned int TagType, unsigned int * Count,TagIds *value);
short __declspec(dllexport) __stdcall MultipleTagIdentify(HANDLE hCom, unsigned int TagType, unsigned char * Count,TagIds *value);
short __declspec(dllexport) __stdcall MultipleTagIdentifyEx(HANDLE hCom, unsigned int TagType, unsigned char * Count,TagIds *value);
short __declspec(dllexport) __stdcall ReadSingleTag(HANDLE hCom, unsigned int TagType, unsigned char Addr,unsigned char Length,unsigned char *Id,unsigned char *value) ;
short __declspec(dllexport) __stdcall ReadSingleTag0(HANDLE hCom, unsigned int TagType, unsigned char *Id,unsigned char Addr,unsigned char Length,unsigned char *value) ;
short __declspec(dllexport) __stdcall WriteSingleTag(HANDLE hCom, unsigned int TagType, unsigned char *Id,unsigned char Addr,unsigned char Length,unsigned char *value,unsigned char *Result);
short __declspec(dllexport) __stdcall WriteSingleTag0(HANDLE hCom, unsigned int TagType, unsigned char *Id,unsigned char Addr,unsigned char Length,unsigned char *value,unsigned char *Result);
short __declspec(dllexport) __stdcall IsoLockTag(HANDLE hCom, unsigned char *Id,unsigned char Addr,unsigned char Length);
short __declspec(dllexport) __stdcall LockTag0(HANDLE hCom, unsigned int TagType, unsigned char *Id,unsigned char Addr,unsigned char *value);
short __declspec(dllexport) __stdcall QueryLock(HANDLE hCom, unsigned int TagType, unsigned char *Id,unsigned char Addr,unsigned char Length,unsigned char *value) ;
short __declspec(dllexport) __stdcall QueryLock0(HANDLE hCom, unsigned int TagType, unsigned char *Id,unsigned char Addr,unsigned char Length,unsigned char *value) ;

short __declspec(dllexport) __stdcall Class1ProgramID(HANDLE hCom, unsigned char Length,unsigned char *Id) ;

short __declspec(dllexport) __stdcall InitGen2Tag(HANDLE hCom,unsigned char Length);
short __declspec(dllexport) __stdcall Gen2TagContentList (HANDLE hCom, Gen2TagList * Data);
short __declspec(dllexport) __stdcall Gen2ReadTag(HANDLE hCom,unsigned char MemBank,unsigned  Addr,unsigned char Length,unsigned char * Data) ;
short __declspec(dllexport) __stdcall Gen2WriteTag(HANDLE hCom,unsigned char MemBank,unsigned  Addr,unsigned char  Length,unsigned char * Data1) ;
short __declspec(dllexport) __stdcall Gen2ReadTagWithEpc(HANDLE hCom,unsigned int Password,unsigned char MemBank,unsigned  Addr,unsigned char ReadLen,unsigned char  *ReadData,unsigned char Scope,unsigned char Length,unsigned char *MaskData) ;
short __declspec(dllexport) __stdcall Gen2WriteTagWithEpc(HANDLE hCom,unsigned int Password,unsigned char MemBank,unsigned  Addr,unsigned char WriteLen,unsigned char  *WriteData,unsigned char Scope,unsigned char Length,unsigned char *MaskData);
short __declspec(dllexport) __stdcall Gen2ChangeEAS (HANDLE hCom,unsigned int Password,unsigned char EASFlag,unsigned char Scope,unsigned char Length,unsigned char *MaskData) ;
short __declspec(dllexport) __stdcall Gen2EASAlarm (HANDLE hCom);
short __declspec(dllexport) __stdcall Gen2SetAccessPassword(HANDLE hCom,unsigned int Password,unsigned int Password2,unsigned char Scope,unsigned char Length,unsigned char *MaskData);
short __declspec(dllexport) __stdcall Gen2GetAccessPassword(HANDLE hCom,unsigned int Password,unsigned int * Password2,unsigned char Scope,unsigned char Length,unsigned char *MaskData) ;
short __declspec(dllexport) __stdcall Gen2SetKillPassword (HANDLE hCom,unsigned int Password,unsigned int Password2,unsigned char Scope,unsigned char Length,unsigned char *MaskData);
short __declspec(dllexport) __stdcall Gen2GetKillPassword (HANDLE hCom,unsigned int Password,unsigned int * Password2,unsigned char Scope,unsigned char Length,unsigned char *MaskData) ;
short __declspec(dllexport) __stdcall Gen2LockTag (HANDLE hCom,unsigned int Password,Gen2LockFlags* LockFlag,unsigned char Scope,unsigned char Length,unsigned char *MaskData) ;
short __declspec(dllexport) __stdcall Gen2KillTag(HANDLE hCom,unsigned int Password,unsigned char Scope,unsigned char Length,unsigned char *MaskData) ;
short __declspec(dllexport) __stdcall GetTagIds(HANDLE hCom, unsigned char * Count,TagIds *value) ;

short __declspec(dllexport) __stdcall AntennaQuantity (HANDLE hCom,unsigned short Quantity);

short __declspec(dllexport) __stdcall GetFrequency (HANDLE hCom, unsigned short *Channel, unsigned short   *MaxChannel);
short __declspec(dllexport) __stdcall SetFrequency (HANDLE hCom, unsigned short Channel);
short __declspec(dllexport) __stdcall GetTrigState (HANDLE hCom);
short __declspec(dllexport) __stdcall SetRelayState(HANDLE hCom, unsigned char Mask, unsigned char State);
short __declspec(dllexport) __stdcall BeepControl(HANDLE hCom, unsigned char ControlType);

short __declspec(dllexport) __stdcall SetIdmData(HANDLE hCom, unsigned char order,unsigned char match_length, unsigned int count,TagIds *value);
short __declspec(dllexport) __stdcall GetIdmData (HANDLE hCom, unsigned char * moreFlag,unsigned int *count,TagIds *value) ;
short __declspec(dllexport) __stdcall SetOLEnable (HANDLE hCom,unsigned char flag) ;
short __declspec(dllexport) __stdcall GetOLData(HANDLE hCom, unsigned char * moreFlag,unsigned int *count,OLTagIds *value);
short __declspec(dllexport) __stdcall SetReaderDateTime(HANDLE hCom,DateTime * dateTime) ;
short __declspec(dllexport) __stdcall GetReaderDateTime(HANDLE hCom,DateTime * dateTime) ;
